<template>
  <nav class="level">
    <div class="level-item has-text-centered">
      <div>
        <p class="title">Video Archive</p>
      </div>
    </div>
    <div v-if="token" class="navbar-end">
      <div class="navbar-item">
        <div class="buttons">
          <a class="button is-dark" @click="logout">
            <strong>Log out</strong>
          </a>
        </div>
      </div>
    </div>
  </nav>

  <Archive v-if="token" :token="token" :input-size="inputSize"/>

  <div v-else class="columns is-mobile is-centered">
    <div class="column is-half">
      <form class="mb-6" @submit="login">
        <div class="field is-horizontal">
          <div class="field-label is-normal">
            <label class="label">Username</label>
          </div>
          <div class="field-body">
            <div class="field is-narrow">
              <div class="control">
                <input class="input" type="text" v-model="username" :size="inputSize" required/>
              </div>
            </div>
          </div>
        </div>
        <div class="field is-horizontal">
          <div class="field-label is-normal">
            <label class="label">Password</label>
          </div>
          <div class="field-body">
            <div class="field is-narrow">
              <div class="control">
                <input class="input" type="password" v-model="password" :size="inputSize" required/>
              </div>
            </div>
          </div>
        </div>
        <div class="field is-horizontal">
          <div class="field-label is-normal">
            <label class="label"></label>
          </div>
          <div class="field-body has-text-left">
            <div class="field">
              <div class="control">
                <button class="button is-link" type="submit">Login</button>
              </div>
            </div>
          </div>
        </div>
      </form>
      <div v-if="error" class="notification is-danger">
        <button class="delete" @click="error = false"></button>
        Login error. Wrong username or password.
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue'
import Archive from './components/Archive.vue'
import axios from "axios";
import {SERVER_URL, TOKEN_KEY} from "./consts";

export default defineComponent({
  name: 'App',
  components: {
    Archive
  },
  data() {
    return {
      token: null,
      username: '',
      password: '',
      error: false,
      inputSize: 37
    }
  },
  created() {
    console.log(SERVER_URL)
    this.token = window.localStorage.getItem(TOKEN_KEY)
  },
  methods: {
    login(e) {
      e.preventDefault()
      if (this.username && this.password) {
        axios.post(SERVER_URL + '/login/', {
          username: this.username,
          password: this.password
        }).then(res => {
          window.localStorage.setItem(TOKEN_KEY, res.data.token)
          this.token = res.data.token
        }).catch(_ => this.error = true )
      }
    },
    logout() {
      window.localStorage.removeItem(TOKEN_KEY)
      this.token = null
    }
  }
})
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 20px;
}
</style>